<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>


  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container p-3">
    <div class="row">
      <div class="col-sm-12 text-center">
        <h3> LỊCH SỬ HỌC TẬP</h3>
      </div>
    </div>
    <div class="row form-group py-3 bg-light rounded">
      <label class="col-sm-2 col-form-label text-center"><b>Student</b></label>
      <div class="col-sm-3">
        <select id="select-student" class="form-control">
          <option value="0">--Select Student--</option>
        </select>
      </div>
      <label class="col-sm-2 col-form-label text-center"><b>Subject</b></label>
      <div class="col-sm-3">
        <select id="select-subject" class="form-control">
          <option value="0">--Select Subject--</option>
        </select>
      </div>
      <div class="col-sm-2">
        <button id="btn-filter" class="btn btn-success w-100">Filter Data</button>
      </div>
    </div>
    <hr>
    <div class="row form-group">
      <div class="col-sm-12">
        <table id="table-grade" class="table table-bordered table-striped table-hover">
          <thead class="thead-dark">
            <tr>
              <th>No.</th>
              <th>Student</th>
              <th>Subject</th>
              <th>Grade</th>
              <th>Exam Date</th>
            </tr>
          </thead>
          <tbody>

          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gStudents = [
    {
      id: 1, // tự tăng
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015
    },
    {
      id: 2, // tự tăng
      studentCode: "1356784",
      firstname: "Nguyen Van",
      lastname: "Ngoc",
      age: 14,
      email: "ngoc@gmail.com",
      studyYear: 2019
    },
    {
      id: 3, // tự tăng
      studentCode: "1356785",
      firstname: "Huynh Van",
      lastname: "Banh",
      age: 19,
      email: "banh@gmail.com",
      studyYear: 2014
    },
    {
      id: 4, // tự tăng
      studentCode: "1356786",
      firstname: "Le Van",
      lastname: "Si",
      age: 20,
      email: "si@gmail.com",
      studyYear: 2013
    },
    {
      id: 5, // tự tăng
      studentCode: "1356787",
      firstname: "Tran Thi",
      lastname: "Xinh",
      age: 18,
      email: "xinh@gmail.com",
      studyYear: 2015
    },

  ];

  var gSubjects = [
    {
      id: 1, // tự tăng
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1"
    },
    {
      id: 2, // tự tăng
      subjectCode: "MATH102",
      subjectName: "Tiếng Anh"
    },
    {
      id: 3, // tự tăng
      subjectCode: "MATH103",
      subjectName: "Tin học 1"
    },
    // điền thêm 04 môn học nữa
  ];

  var gGrades = [
    {
      id: 1, // tự tăng
      studentId: 2,
      subjectId: 1,
      grade: 8,
      examDate: "13/04/2021"
    },
    {
      id: 2, // tự tăng
      studentId: 2,
      subjectId: 1,
      grade: 8,
      examDate: "15/04/2021"
    },
    {
      id: 3, // tự tăng
      studentId: 3,
      subjectId: 1,
      grade: 7,
      examDate: "13/04/2021"
    },
    {
      id: 4, // tự tăng
      studentId: 4,
      subjectId: 1,
      grade: 10,
      examDate: "13/04/2021"
    },
    {
      id: 5, // tự tăng
      studentId: 5,
      subjectId: 1,
      grade: 3,
      examDate: "14/04/2021"
    },
    {
      id: 6, // tự tăng
      studentId: 1,
      subjectId: 2,
      grade: 8,
      examDate: "13/05/2021"
    },
    {
      id: 7, // tự tăng
      studentId: 2,
      subjectId: 2,
      grade: 8,
      examDate: "13/05/2021"
    },
    {
      id: 8, // tự tăng
      studentId: 3,
      subjectId: 2,
      grade: 8,
      examDate: "15/05/2021"
    },
    {
      id: 9, // tự tăng
      studentId: 4,
      subjectId: 2,
      grade: 9.5,
      examDate: "13/05/2021"
    },
    {
      id: 9, // tự tăng
      studentId: 5,
      subjectId: 2,
      grade: 10,
      examDate: "13/05/2021"
    },
  ];

  var gSTT = 1;

  const gTABLE_ROW = ["id", "studentId", "subjectId", "grade", "examDate"];
  const gSTT_COL = 0;
  const gSTUDENT_COL = 1;
  const gSUBJECT_COL = 2;
  const gGRADE_COL = 3;
  const gEXAM_DATE_COL = 4;

  var gTableGrade = $("#table-grade").DataTable({
    columns: [
      { data: gTABLE_ROW[gSTT_COL] },
      { data: gTABLE_ROW[gSTUDENT_COL] },
      { data: gTABLE_ROW[gSUBJECT_COL] },
      { data: gTABLE_ROW[gGRADE_COL] },
      { data: gTABLE_ROW[gEXAM_DATE_COL] },
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function () {
          return gSTT++;
        }
      },
      {
        targets: gSTUDENT_COL,
        render: getStudentNameByStudentId
      },
      {
        targets: gSUBJECT_COL,
        render: getSubjectNameBySubjectId
      }
    ]
  })


  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    // gán sự kiện click button Filter Data
    $(document).on("click", "#btn-filter", onBtnFilterClick);
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện tải trang/F5
  function onPageLoading() {
    loadStudentDataToSelect();
    loadSubjectDataToSelect();
    showDataToTable(gGrades);
  }

  // function xử lý sự kiện click button Filter Data
  function onBtnFilterClick() {
    // khai báo đối tượng chứa dữ liệu
    let vFilterData = {
      studentId: "",
      subjectId: ""
    };
    // B1: Thu thập dữ liệu
    getFilterData(vFilterData);
    debugger;
    // B2: Kiểm tra dữ liệu
    let vDataValid = checkFilterData(vFilterData);
    if (vDataValid) {
      // B3: Xử lý hiển thị
      let vFilteredObject = findStudentByFilter(vFilterData);
      var vTable = $("#table-grade"); //truy vấn đến bảng có id = table-users
      vTable.find("tr:gt(0)").html(''); //xóa trắng bảng (k xóa header)
      if (vFilteredObject.length > 0) {
        //hiện thông báo đã tìm được
        alert("Tìm thấy " + vFilteredObject.length + " kết quả phù hợp");
        //hiển thị danh sách dữ liệu tìm được ra table
        showDataToTable(vFilteredObject);
      }
      else {
        alert("Không tìm thấy kết quả phù hợp");
        return false;
      }

    }
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function gán data cho Table
  function showDataToTable(paramData) {
    gSTT = 1;
    gTableGrade.clear();
    gTableGrade.rows.add(paramData);
    gTableGrade.draw();
  }

  // function lấy tên Student theo studentId
  function getStudentNameByStudentId(paramStudentId) {
    let vIndex = 0;
    let vFound = false;
    let vStudentName = "";
    while (!vFound && vIndex < gStudents.length) {
      if (gStudents[vIndex].id == paramStudentId) {
        vStudentName = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname;
        vFound = true;
      }
      vIndex++;
    }
    return vStudentName;
  }


  // function lấy tên Subject theo Subject ID
  function getSubjectNameBySubjectId(paramSubjectId) {
    let vIndex = 0;
    let vFound = false;
    let vSubjectName = "";
    while (!vFound && vIndex < gSubjects.length) {
      if (gSubjects[vIndex].id == paramSubjectId) {
        vSubjectName = gSubjects[vIndex].subjectName;
        vFound = true;
      }
      vIndex++;
    }
    return vSubjectName;
  }


  // function thu thập dữ liệu filter data trên form
  // function return đối tượng paramFilterData được tham số hóa
  function getFilterData(paramFilterData) {
    paramFilterData.studentId = $("#select-student").val();
    paramFilterData.subjectId = $("#select-subject").val();
  }

  // function kiểm tra dữ liệu
  function checkFilterData(paramFilterData) {
    if (paramFilterData.studentId == "0" && paramFilterData.subjectId == "0") {
      alert("Please select Student or Subject to filter data");
      return false;
    }
    return true;
  }


  function findStudentByFilter(paramKeyWordObj) {
    "use strict";
    const bArrResultObj = [];
    //kiểm tra truồng hợp nếu StudentID và SubjectID được nhập
    if (paramKeyWordObj.studentId != "0" && paramKeyWordObj.subjectId != "0") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bIStudentObj = gGrades[bI];
        //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
        if (paramKeyWordObj.studentId == bIStudentObj.studentId && paramKeyWordObj.subjectId == bIStudentObj.subjectId) {
          //thêm đối tượng thỏa mãn điều kiện vào array
          bArrResultObj.push(bIStudentObj);
        }
      }
    }

    //kiểm tra trường hợp nếu StudentID hoặc SubjectID được nhập
    if (paramKeyWordObj.studentId != "0" || paramKeyWordObj.subjectId != "") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bIStudentObj = gGrades[bI];
        //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
        if (paramKeyWordObj.studentId == bIStudentObj.studentId ||
          paramKeyWordObj.subjectId == bIStudentObj.subjectId) {
          //thêm đối tượng thỏa mãn điều kiện vào array
          bArrResultObj.push(bIStudentObj);
        }
      }
    }

    return bArrResultObj;
  }





  // function load student data vào select
  function loadStudentDataToSelect() {
    for (let bStudent of gStudents) {
      $("#select-student").append(
        $("<option>")
          .val(bStudent.id)
          .text(bStudent.firstname + " " + bStudent.lastname)
      );
    }
  }

  // function load subject data vào select
  function loadSubjectDataToSelect() {
    for (let bSubject of gSubjects) {
      $("#select-subject").append(
        $("<option>")
          .val(bSubject.id)
          .text(bSubject.subjectName)
      );
    }
  }

</script>

</html>